
$include "rapidq.inc"
$include "fmod3.70.inc"
'-----------------
dim f$ as string
dim lngstream as long
dim lngchannel as long
dim Opendialog as QOpendialog 
OpenDialog.Filter = "Fichiers Multimdia (*.wav, *.mp3, *.ogg, *.wma)|*.wav;*.ogg;*.mp3;*.wma" 
Opendialog.filterindex = 1
dim position as integer
dim posl as integer
    dim vl as long
    dim vr as long    

declare sub timerf
declare sub quit
declare sub init
declare sub play
declare sub stop
declare sub openf
declare sub pause
declare sub openf

application.showhint = 1
application.hintcolor = &hb5ff00

dim font as qfont
font.name = "arial" 
font.addstyles(fsbold, fsitalic)
font.color = clblue
font.size = 9

dim timer1 as qtimer
timer1.ontimer = timerf
timer1.enabled = 1  
  
create form as qform
 width = 550
 height = 220
 caption = "gg_fmod_player"
 center
 onShow = init
    create infolabel as qlabel
        top = 20
        left = 35
        width = 50
        transparent = 1
        font = font
        'color = &hff8200
    end create
    create info2label as qlabel
        top = 60
        left = 35
        width = 100
        transparent = 1
        font = font
        'color = &hff8200
    end create
        create info3label as qlabel
        top = 140
        left = 35
        width = 100
        transparent = 1
        font = font
        'color = &hff8200
    end create
    create playb as qbutton
        cursor = crhandpoint
        left = 35
        top = 100
        height = 30
        width = 30
        onclick = play
        caption = ">"
        visible = 0
        showhint = 1
        hint = "Lecture"
    end create
    create stopb as qbutton
        cursor = crhandpoint
        left = 70
        top = 100
        height = 30
        width = 30
        onclick = stop
        caption = "o"        
        visible = 0
    end create   
    create openb as qbutton
        cursor = crhandpoint
        left = 105
        top = 100
        height = 30
        width = 30
        onclick = openf
        caption = "-^-"
        showhint = 1
        hint = "Ouvrir fichier"
    end create
    create pauseb as qbutton
        cursor = crhandpoint
        left = 140
        top = 100
        height = 30
        width = 30
        onclick = pause
        caption = "="
        showhint = 1
        hint = "Pause"
        visible = 0
    end create
    create quitb as qbutton
        cursor = crhandpoint
        left = 233
        top = 100
        height = 30
        width = 30
        onclick = quit
        caption = "...->"
        showhint = 1
        hint = "Quitter"
    end create
    create lgauge as QGauge
        left = 300
        top = 40
        width = 220
        height = 10
        max = 700
    end create
    create rgauge as QGauge
        left = 300
        top = 80
        width = 220
        height = 10
        max = 7000000
        foreColor = &hffff00
    end create
    create tgauge as QGauge
        left = 300
        top = 120
        width = 220
        height = 10
        max = 100
        foreColor = &hff0000
    end create
end create


form.showmodal

'=============================
sub quit
    fsound_close
    application.terminate
end sub
'=============================
sub init   
    timer1.enabled = 0
    fsound_init(44100, 32, 0)
end sub
'=============================
sub play
    if f$="" then
        openf
    end if
        init
    timer1.enabled = 1
    timer1.interval = 100
    lngstream = fsound_stream_open (f$, fsound_2d, 0,0)    
    channel = fsound_stream_play (fsound_free,lngstream)
    if lngstream = 0 then
        info3label.caption = str$(lngstream)+ fsound_geterrorstring(fsound_geterror)
    end if   
    stopb.visible = 1
    pauseb.visible = 1     
    infolabel.color=&hff8200
    infolabel.caption = str$(fsound_getfrequency(4))+ "htz"    
end sub
'=============================
sub stop
    fsound_stream_stop(lngstream)
    fsound_stream_close(lngstream)
    infolabel.caption = "Stop"
end sub
'=============================
sub openf  
    timer1.enabled = 0
    fsound_stream_stop(lngstream)
    form.repaint
    if opendialog.execute then
        f$ = opendialog.filename
        for i = len(f$) to 1 step -1
            a$ = mid$(f$,i,1)
            if a$ = "\" then exit for
                ff$ = ff$+a$  
        next
        file$ = reverse$(ff$)
        info3label.caption = file$
    end if
    playb.visible = 1
end sub    
'=============================
sub pause
    paused = fsound_getpaused(channel)
    infolabel.caption = "En pause"
    if paused = 0 then
        fsound_setpaused(channel,1)
    else
        fsound_setpaused(channel,0)
        infolabel.caption = str$(fsound_getfrequency(0))+ "hrz"
    end if
end sub
'=============================
sub timerf
    l = fsound_getcurrentlevels (lngchannel,vl,vr)
    posl = fsound_stream_getlengthMs(lngstream)
    time = fsound_stream_gettime(lngstream)    
    posgr = posl-time
   
    'vul=val(right$(str$(int(vl/10000)),4))/10
    'vur=val(right$(str$(int(vr/10000)),4))/10
    vul=val(right$(str$(int(vl/100)),6))/1000    
    vur=val(right$(str$(int(vr/10)),8))
    rgauge.position = vur
    lgauge.position = vul
    tgp = (100/posl)
    tgauge.position = tgp*time  
    info2label.caption = str$(posl)+" position = " + str$(posgr/1000)+"  /  "+str$(time/1000)+" seconds"+" "+str$(tgauge.position)   
end sub

